/*
 * Counter
 * -------
 *
 * Read the program below this comment first.
 *
 * Then, compile it using the following commands:
 *
 *		$ gcc FILE
 *		$ gcc -std=c99 FILE
 *
 * Which one works and which one does not? Why?
 *
 * When you eventually get to the “Acceptance” stage after you see the results,
 * try to figure out which dialect is this program written in.
 */

#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

void counter(int n)
{
	bool tick(void)
	{
		printf("%d\n", n);
		return n-- > 0;
	}

	while (tick())
		sleep(1);
}

int main(void)
{
	counter(5);
	return EXIT_SUCCESS;
}
