#include <stdio.h>
#include <stdlib.h>

#include <ncurses.h>

static
void draw(void)
{
	/* TODO: Remove this line. */
	printw("Draw here!");

	/* This will retrieve screen dimensions. */
	int height, width;
	getmaxyx(stdscr, height, width);

	/* Enable colour output. */
	attron(COLOR_PAIR(1));

	/* TODO: Draw a circle with the center in the center of the screen.
	 * Its radius should be ⅓ of the «shorter» screen dimension.
	 *
	 * To put text at position X, Y, use
	 *
	 *     mvprintw(Y, X, FORMAT, ARGS…);
	 *
	 * where ‹FORMAT› and ‹ARGS…› work just like ‹printf()›. */
}

int main(void)
{
	/* Initialize screen. */
	initscr();
	noecho();

	/* Add some color pair. */
	start_color();
	init_pair(1, COLOR_RED, COLOR_RED);

	draw();

	/* Draw the screen and wait for user input. */
	refresh();
	getch();

	/* Leave curses. */
	endwin();
	return EXIT_SUCCESS;
}
