#include <errno.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <err.h>
#include <grp.h>
#include <pwd.h>
#include <sys/types.h>
#include <unistd.h>

static
bool print_users(void)
{
	/* TODO (1/2):
	 * Print all users and highlight those matching process RUID or EUID.
	 * Return ‹true› if no errors were encountered. */
}

/* TIP: You may want to implement an auxiliary function like this:
 * bool contains(size_t size, gid_t gids[size], gid_t gid) */

static
bool print_groups(void)
{
	/* TODO (2/2):
	 * Print all groups and highlight those matching process RGID, EGID
	 * or any of the supplementary groups. Return ‹true› if no errors were
	 * encountered.
	 *
	 * TIP: See ‹man 3 getgroups› and find out what happens when you
	 *      call ‹getgroups(0, NULL)›. */
}

/* You do not need to change anything below this line. */

static inline
void usage(const char *argv0)
{
	fprintf(stderr, "usage: %s users|groups\n", argv0);
}

int main(int argc, char *argv[])
{
	if (argc != 2) {
		usage(argv[0]);
		return EXIT_FAILURE;
	}

	int status = EXIT_FAILURE;
	if (strcmp(argv[1], "users") == 0) {
		if (print_users())
			status = EXIT_SUCCESS;
	} else if (strcmp(argv[1], "groups") == 0) {
		if (print_groups())
			status = EXIT_SUCCESS;
	} else {
		usage(argv[0]);
	}

	return status;
}
