#include "ack.h"

#include <assert.h>

long long ack(long long m, long long n)
{
	assert(m >= 0);
	assert(n >= 0);

	if (m == 0)
		return n + 1;

	if (n == 0)
		return ack(m - 1, 1);

	return ack(m - 1, ack(m, n - 1));
}
